/*
 * Copy me if you can.
 * by 20h
 */
#include <u.h>
#include <libc.h>

char *
read_line(int s)
{
	char *ret;
	int l;

	ret = nil;
	l = 0;

	while((ret = realloc(ret, ++l)) != nil && read(s, &ret[l - 1], 1) > 0 && l < 1024)
	{
		if(l > 1)
		{
			if(ret[l - 1] == '\n')
			{
				ret[l - 1] = '\0';
				if(ret[l - 2] == '\r')
					ret[l - 2] = '\0';
				return ret;
			}
		}
	}

	if(ret != nil)
		free(ret);
	return nil;
}

void
read_httphdr(int s)
{
	char *ret;

	while((ret = read_line(s)) != nil && ret[0] != '\0')
		free(ret);

	return;
}

int
read_pls(int fd, char **host, char **port, char **path)
{
	char *ret, *h, *a;

	while((ret = read_line(fd)) != nil && ret[0] != '\0')
	{
		if(!strncmp(ret, "File", 4))
		{
			h = strchr(ret + 13, ':');
			if(h == nil)
			{
				*port = strdup("8000");
				h = ret + 13;
			} else {
				*h++ = '\0';
			}
			a = strchr(h, '/');
			if(a != nil)
			{
				*a++ = '\0';
			} else {
				*path = strdup("");
			}

			*host = strdup(ret + 13);
			if(*port == nil)
				*port = strdup(h);
			if(*path == nil)
				*path = strdup(a);

			free(ret);
			return 0;
		}
		free(ret);
	}

	return 1;
}

void
main(void)
{
	int fd, l;
	char buf[512], *path, *host, *port;

	host = port = path = nil;

	if(read_pls(0, &host, &port, &path))
	{
		print("Wrong pls format.\n");
		exits(0);
	}

	fd = dial(netmkaddr(host, "tcp", port), 0, 0, 0);
	if(fd < 0)
	{
		perror("dial: %r");
		exits(0);
	}

	fprint(fd, "GET /%s HTTP/1.0\r\nUser-Agent: streamget/1st\r\n"
			"Icy-MetaData:0\r\n\r\n", path);
	free(host);
	free(port);
	free(path);

	read_httphdr(fd);

	while((l = read(fd, buf, 512)) > 0)
		write(1, buf, l);

	exits(0);
}

		